]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
QoS-Graphen wieder eingebaut.
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0t4" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 #ipfiremake linux XEN=1
340 ipfiremake linux
341 ipfiremake ipp2p
342 ipfiremake fcdsl
343 ipfiremake fcdsl2
344 ipfiremake fcdslsl
345 ipfiremake fcdslusb
346 ipfiremake fcdslslusb
347 # ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake cpio
352 ipfiremake klibc
353 ipfiremake mkinitcpio
354 ipfiremake udev KLIBC=1
355 ipfiremake expat
356 ipfiremake gdbm
357 ipfiremake gmp
358 ipfiremake pam
359 ipfiremake openssl
360 ipfiremake curl
361 ipfiremake python
362 ipfiremake libnet
363 ipfiremake libjpeg
364 ipfiremake libpng
365 ipfiremake libtiff
366 ipfiremake libart
367 ipfiremake freetype
368 ipfiremake gd
369 ipfiremake popt
370 ipfiremake pcre
371 ipfiremake slang
372 ipfiremake newt
373 ipfiremake libcap
374 ipfiremake pciutils
375 ipfiremake usbutils
376 ipfiremake libxml2
377 ipfiremake libxslt
378 ipfiremake BerkeleyDB
379 ipfiremake mysql
380 ipfiremake cyrus-sasl
381 ipfiremake openldap
382 ipfiremake apache2
383 ipfiremake php
384 ipfiremake apache2 PASS=C
385 ipfiremake arping
386 ipfiremake beep
387 ipfiremake bind
388 ipfiremake capi4k-utils
389 ipfiremake cdrtools
390 ipfiremake dnsmasq
391 ipfiremake dosfstools
392 ipfiremake reiserfsprogs
393 ipfiremake squashfstools
394 ipfiremake sysfsutils
395 ipfiremake ntfs-3g
396 ipfiremake ethtool
397 ipfiremake ez-ipupdate
398 ipfiremake fcron
399 ipfiremake GD
400 ipfiremake GD-Graph
401 ipfiremake GD-TextUtil
402 ipfiremake gnupg
403 ipfiremake hdparm
404 ipfiremake ibod
405 ipfiremake initscripts
406 ipfiremake whatmask
407 ipfiremake iptables
408 ipfiremake libupnp
409 ipfiremake ipp2p IPT=1
410 ipfiremake moblock
411 ipfiremake linux-igd
412 ipfiremake ipac-ng
413 ipfiremake ipaddr
414 ipfiremake iptstate
415 ipfiremake iputils
416 ipfiremake l7-protocols
417 ipfiremake isdn4k-utils
418 ipfiremake mISDN
419 ipfiremake hwdata
420 ipfiremake kudzu
421 ipfiremake logrotate
422 ipfiremake logwatch
423 ipfiremake misc-progs
424 ipfiremake mtools
425 ipfiremake nano
426 ipfiremake nasm
427 ipfiremake URI
428 ipfiremake HTML-Tagset
429 ipfiremake HTML-Parser
430 ipfiremake Compress-Zlib
431 ipfiremake Digest
432 ipfiremake Digest-SHA1
433 ipfiremake Digest-HMAC
434 ipfiremake libwww-perl
435 ipfiremake Net-DNS
436 ipfiremake Net-IPv4Addr
437 ipfiremake Net_SSLeay
438 ipfiremake IO-Stringy
439 ipfiremake Unix-Syslog
440 ipfiremake Mail-Tools
441 ipfiremake MIME-Tools
442 ipfiremake Net-Server
443 ipfiremake Convert-TNEF
444 ipfiremake Convert-UUlib
445 ipfiremake Archive-Tar
446 ipfiremake Archive-Zip
447 ipfiremake Text-Tabs+Wrap
448 ipfiremake Locale-Country
449 ipfiremake XML-Parser
450 ipfiremake MP3-Info
451 ipfiremake MP3-Tag
452 ipfiremake glib
453 ipfiremake GeoIP
454 ipfiremake fwhits
455 ipfiremake noip_updater
456 ipfiremake ntp
457 ipfiremake openssh
458 ipfiremake openswan
459 ipfiremake pptpclient
460 ipfiremake rrdtool
461 ipfiremake setserial
462 ipfiremake setup
463 ipfiremake snort
464 ipfiremake snortsnarf
465 ipfiremake oinkmaster
466 ipfiremake squid
467 ipfiremake squid-graph
468 ipfiremake squidguard
469 ipfiremake calamaris
470 ipfiremake tcpdump
471 ipfiremake traceroute
472 ipfiremake vlan
473 ipfiremake wireless
474 ipfiremake libsafe
475 ipfiremake 3c5x9setup
476 ipfiremake pakfire
477 ipfiremake java
478 ipfiremake spandsp
479 ipfiremake lzo
480 ipfiremake openvpn
481 ipfiremake pammysql
482 ipfiremake ghostscript
483 ipfiremake cups
484 ipfiremake samba
485 ipfiremake sudo
486 ipfiremake mc
487 ipfiremake wget
488 ipfiremake bridge-utils
489 ipfiremake screen
490 ipfiremake hddtemp
491 ipfiremake smartmontools
492 ipfiremake htop
493 ipfiremake postfix
494 ipfiremake fetchmail
495 ipfiremake cyrusimap
496 ipfiremake webcyradm
497 ipfiremake mailx
498 ipfiremake clamav
499 ipfiremake spamassassin
500 ipfiremake amavisd
501 ipfiremake stund
502 ipfiremake libpri
503 # ipfiremake bristuff
504 ipfiremake asterisk
505 ipfiremake mpg123
506 ipfiremake libmad
507 ipfiremake libogg
508 ipfiremake libvorbis
509 ipfiremake lame
510 ipfiremake sox
511 ipfiremake gnump3d
512 ipfiremake libsigc++
513 ipfiremake ctorrent
514 ipfiremake applejuice
515 ipfiremake ocaml
516 ipfiremake mldonkey
517 ipfiremake libtorrent
518 ipfiremake rtorrent
519 ipfiremake rsync
520 ipfiremake tcpwrapper
521 ipfiremake portmap
522 ipfiremake nfs
523 ipfiremake nmap
524 ipfiremake mbmon
525 ipfiremake iftop
526 ipfiremake ncftp
527 ipfiremake cftp
528 ipfiremake etherwake
529 ipfiremake ethereal
530 ipfiremake tftp-hpa
531 ipfiremake bwm-ng
532 ipfiremake tripwire
533 ipfiremake sysstat
534 ipfiremake vsftpd
535 ipfiremake alsa
536 ipfiremake mp3blaster
537 ipfiremake which
538 }
539
540 buildinstaller() {
541 # Run installer scripts one by one
542 LOGFILE="$BASEDIR/log/_build.installer.log"
543 export LOGFILE
544 ipfiremake syslinux
545 ipfiremake as86
546 ipfiremake mbr
547 ipfiremake memtest
548 installmake linux-libc-header
549 installmake binutils
550 ipfiremake uClibc PASS=1
551 ipfiremake gcc INST=1
552 installmake uClibc PASS=2
553 installmake gcc INST=2
554 installmake uClibc PASS=3
555 installmake busybox
556 installmake udev
557 installmake slang
558 installmake newt
559 installmake gettext
560 installmake kbd
561 installmake popt
562 installmake sysvinit
563 installmake misc-progs
564 installmake e2fsprogs
565 installmake libaal
566 installmake reiser4progs
567 installmake reiserfsprogs
568 installmake sysfsutils
569 installmake util-linux
570 installmake pciutils
571 installmake zlib
572 installmake mtd
573 installmake wget
574 installmake hwdata
575 installmake kudzu
576 installmake installer
577 installmake initrd
578 }
579
580 buildpackages() {
581 LOGFILE="$BASEDIR/log/_build.packages.log"
582 export LOGFILE
583 echo "... see detailed log in _build.*.log files" >> $LOGFILE
584
585 installmake strip
586
587 # Generating list of packages used
588 echo -n "Generating packages list from logs" | tee -a $LOGFILE
589 rm -f $BASEDIR/doc/packages-list
590 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
591 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
592 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
593 fi
594 done
595 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
596 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
597 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
598 rm -f $BASEDIR/doc/packages-list
599 # packages-list.txt is ready to be displayed for wiki page
600 beautify message DONE
601
602 # Create images for install
603 if [ "$DEVEL" == "1" ]; then
604 ipfiremake cdrom ED=devel
605 fi
606 ipfiremake cdrom ED=full
607
608 # Check if there is a loop device for building in virtual environments
609 if [ -e /dev/loop0 ]; then
610 ipfiremake usb-stick
611 fi
612 ipfiremake pxe
613 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
614
615 ipfirepackages
616
617 # Cleanup
618 stdumount
619 rm -rf $BASEDIR/build/tmp/*
620
621 # Generating total list of files
622 echo -n "Generating files list from logs" | tee -a $LOGFILE
623 rm -f $BASEDIR/log/FILES
624 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
625 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
626 echo "##" >>$BASEDIR/log/FILES
627 echo "## `basename $i`" >>$BASEDIR/log/FILES
628 echo "##" >>$BASEDIR/log/FILES
629 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
630 fi
631 done
632 beautify message DONE
633
634 cd $PWD
635 }
636
637 ipfirepackages() {
638 ipfiredist alsa
639 # ipfiredist amavisd
640 ipfiredist applejuice
641 # ipfiredist asterisk
642 ipfiredist clamav
643 ipfiredist cups
644 ipfiredist cyrus-sasl
645 # ipfiredist fetchmail
646 # ipfiredist gnump3d
647 ipfiredist java
648 ipfiredist libogg
649 ipfiredist libvorbis
650 # ipfiredist mailx
651 # ipfiredist mldonkey
652 ipfiredist mp3blaster
653 ipfiredist mpg123
654 # ipfiredist nfs
655 ipfiredist openldap
656 # ipfiredist postfix
657 ipfiredist samba
658 # ipfiredist sox
659 # ipfiredist spamassassin
660 ipfiredist tripwire
661 ipfiredist vsftpd
662 # ipfiredist webcyradm
663 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
664 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
665 rm -rf $BASEDIR/build/install/packages/*
666 }
667
668 # See what we're supposed to do
669 case "$1" in
670 build)
671 clear
672 BUILDMACHINE=`uname -m`
673 DEVEL=0
674 if [ "$2" == "--devel" ]; then
675 DEVEL=1
676 fi
677 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
678 #only restore on a clean disk
679 if [ ! -f log/cleanup-toolchain-2-tools ]; then
680 if [ ! -n "$PACKAGE" ]; then
681 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
682 prepareenv
683 buildtoolchain
684 else
685 PACKAGENAME=${PACKAGE%.tar.gz}
686 beautify build_stage "Packaged toolchain compilation"
687 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
688 tar zxf $PACKAGE
689 prepareenv
690 else
691 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
692 fi
693 fi
694 else
695 echo -n "Using installed toolchain" | tee -a $LOGFILE
696 beautify message SKIP
697 prepareenv
698 fi
699
700 beautify build_start
701 beautify build_stage "Building LFS"
702 buildbase
703
704 beautify build_stage "Building IPFire"
705 buildipfire
706
707 # Setzen des IPFire Builds
708 if [ "$FIREBUILD" ]; then
709 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
710 else
711 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
712 fi
713
714 beautify build_stage "Building installer"
715 buildinstaller
716
717 beautify build_stage "Building packages"
718 buildpackages
719 beautify build_end
720 ;;
721 shell)
722 # enter a shell inside LFS chroot
723 # may be used to changed kernel settings
724 prepareenv
725 entershell
726 ;;
727 changelog)
728 echo -n "Loading new Changelog from SVN: "
729 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
730 beautify message DONE
731 ;;
732 clean)
733 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
734 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
735 $LOSETUP -d $i 2>/dev/null
736 done
737 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
738 umount $i
739 done
740 stdumount
741 for i in `seq 0 7`; do
742 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
743 umount /dev/loop${i} 2>/dev/null;
744 losetup -d /dev/loop${i} 2>/dev/null;
745 fi;
746 done
747 rm -rf $BASEDIR/build
748 rm -rf $BASEDIR/cdrom
749 rm -rf $BASEDIR/packages
750 rm -rf $BASEDIR/log
751 if [ -h /tools ]; then
752 rm -f /tools
753 fi
754 beautify message DONE
755 ;;
756 downloadsrc)
757 if [ ! -d $BASEDIR/cache ]; then
758 mkdir $BASEDIR/cache
759 fi
760 mkdir -p $BASEDIR/log
761 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
762 FINISHED=0
763 cd $BASEDIR/lfs
764 for c in `seq $MAX_RETRIES`; do
765 if (( FINISHED==1 )); then
766 break
767 fi
768 FINISHED=1
769 cd $BASEDIR/lfs
770 for i in *; do
771 if [ -f "$i" -a "$i" != "Config" ]; then
772 echo -ne "Loading $i"
773 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
774 if [ $? -ne 0 ]; then
775 beautify message FAIL
776 FINISHED=0
777 else
778 if [ $c -eq 1 ]; then
779 beautify message DONE
780 fi
781 fi
782 fi
783 done
784 done
785 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
786 ERROR=0
787 for i in *; do
788 if [ -f "$i" -a "$i" != "Config" ]; then
789 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
790 if [ $? -ne 0 ]; then
791 echo -ne "MD5 difference in lfs/$i"
792 beautify message FAIL
793 ERROR=1
794 fi
795 fi
796 done
797 if [ $ERROR -eq 0 ]; then
798 echo -ne "${BOLD}all files md5sum match${NORMAL}"
799 beautify message DONE
800 else
801 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
802 beautify message FAIL
803 fi
804 cd - >/dev/null 2>&1
805 ;;
806 toolchain)
807 clear
808 prepareenv
809 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
810 buildtoolchain
811 BUILDMACHINE=`uname -m`
812 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
813 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
814 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
815 build/{bin,etc,usr/bin,usr/local} \
816 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
817 log >> $LOGFILE
818 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
819 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
820 stdumount
821 ;;
822 gettoolchain)
823 BUILDMACHINE=`uname -m`
824 # arbitrary name to be updated in case of new toolchain package upload
825 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
826 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
827 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
828 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
829 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
830 cd $BASEDIR/cache/toolchains
831 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
832 if [ $? -ne 0 ]; then
833 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
834 else
835 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
836 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
837 else
838 exiterror "$PACKAGE.md5 did not match, check downloaded package"
839 fi
840 fi
841 else
842 echo "Toolchain is already downloaded. Exiting..."
843 fi
844 ;;
845 othersrc)
846 prepareenv
847 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
848 chroot $LFS /tools/bin/env -i HOME=/root \
849 TERM=$TERM PS1='\u:\w\$ ' \
850 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
851 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
852 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
853 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
854 if [ $? -eq "0" ]; then
855 beautify message DONE
856 else
857 beautify message FAIL
858 fi
859 stdumount
860 ;;
861 svn)
862 case "$2" in
863 update|up)
864 # clear
865 echo -ne "Loading the latest source files...\n"
866 if [ $3 ]; then
867 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
868 else
869 svn update | tee -a $PWD/log/_build.svn.update.log
870 fi
871 if [ $? -eq "0" ]; then
872 beautify message DONE
873 else
874 beautify message FAIL
875 exit 1
876 fi
877 echo -ne "Writing the svn-info to a file"
878 svn info > $PWD/svn_status
879 if [ $? -eq "0" ]; then
880 beautify message DONE
881 else
882 beautify message FAIL
883 exit 1
884 fi
885 chmod 755 $0
886 exit 0
887 ;;
888 commit|ci)
889 clear
890 if [ -f /usr/bin/mcedit ]; then
891 export EDITOR=/usr/bin/mcedit
892 fi
893 if [ -f /usr/bin/nano ]; then
894 export EDITOR=/usr/bin/nano
895 fi
896 echo -ne "Selecting editor $EDITOR..."
897 beautify message DONE
898 if [ -e /sbin/yast ]; then
899 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
900 $0 changelog
901 fi
902 fi
903 update_langs
904 svn commit
905 $0 svn up
906 if [ -n "$FTP_CACHE_URL" ]; then
907 $0 uploadsrc
908 fi
909 ;;
910 dist)
911 if [ $3 ]; then
912 SVN_REVISION=$3
913 fi
914 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
915 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
916 exit 0
917 fi
918 echo -en "REV $SVN_REVISION: Downloading..."
919 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
920 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
921 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
922 evaluate 1
923
924 echo -en "REV $SVN_REVISION: Compressing files..."
925 if [ -e ipfire-source/trunk/make.sh ]; then
926 chmod 755 ipfire-source/trunk/make.sh
927 fi
928 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
929 evaluate 1
930 echo -en "REV $SVN_REVISION: Cleaning up..."
931 rm ipfire-source/ -r
932 evaluate 1
933 ;;
934 diff|di)
935 update_langs
936 echo -ne "Make a local diff to last svn revision"
937 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
938 evaluate 1
939 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
940 svn status
941 ;;
942 esac
943 ;;
944 uploadsrc)
945 PWD=`pwd`
946 cd $BASEDIR/cache/
947 echo -e "Uploading cache to ftp server:"
948 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
949 for i in *; do
950 if [ "$i" == "toolchains" ]; then continue; fi
951 grep -q $i /tmp/ftplist
952 if [ "$?" -ne "0" ]; then
953 echo -ne "$i"
954 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
955 if [ "$?" -ne "0" ]; then
956 beautify message FAIL
957 fi
958 fi
959 done
960 rm -f /tmp/ftplist
961 cd $PWD
962 exit 0
963 ;;
964 upload)
965 case "$2" in
966 iso)
967 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
968 cat <<EOF > .ftp-commands
969 mkdir -p $FTP_ISO_PATH$SVN_REVISION
970 ls -lah
971 quit
972 EOF
973 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
974 rm -f .ftp-commands
975 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
976 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
977 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
978 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
979 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
980 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
981 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
982 fi
983 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
984 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
985 if [ "$?" -eq "0" ]; then
986 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
987 else
988 echo -e "There was an error while uploading the iso to the ftp server."
989 exit 1
990 fi
991 if [ "$3" = "--with-sources-cd" ]; then
992 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
993 fi
994 ;;
995 paks)
996 cat <<EOF > .ftp-commands
997 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
998 ls -lah
999 quit
1000 EOF
1001 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
1002 rm -f .ftp-commands
1003 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
1004 if [ "$?" -eq "0" ]; then
1005 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1006 else
1007 echo -e "There was an error while uploading the packages to the ftp server."
1008 exit 1
1009 fi
1010 ;;
1011 esac
1012 ;;
1013 batch)
1014 if [ "$2" = "--background" ]; then
1015 batch_script
1016 exit $?
1017 fi
1018 if [ `screen -ls | grep -q ipfire` ]; then
1019 echo "Build is already running, sorry!"
1020 exit 1
1021 else
1022 if [ "$2" = "--rebuild" ]; then
1023 export IPFIRE_REBUILD=1
1024 echo "REBUILD!"
1025 else
1026 export IPFIRE_REBUILD=0
1027 fi
1028 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1029 screen -dmS ipfire $0 batch --background
1030 evaluate 1
1031 exit 0
1032 fi
1033 ;;
1034 watch)
1035 watch_screen
1036 ;;
1037 pxe)
1038 case "$2" in
1039 start)
1040 start_tftpd
1041 ;;
1042 stop)
1043 stop_tftpd
1044 ;;
1045 reload|restart)
1046 reload_tftpd
1047 ;;
1048 esac
1049 exit 0
1050 ;;
1051 lang)
1052 update_langs
1053 ;;
1054 packages)
1055 case "$2" in
1056 sign)
1057 sign_packages
1058 ;;
1059 esac
1060 ;;
1061 "")
1062 clear
1063 svn info
1064 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1065 do
1066 case $name in
1067 "IPFIRE: Downloadsrc")
1068 $0 downloadsrc
1069 ;;
1070 "IPFIRE: Build (silent)")
1071 $0 build-silent
1072 ;;
1073 "IPFIRE: Watch Build")
1074 $0 watch
1075 ;;
1076 "IPFIRE: Batch")
1077 $0 batch
1078 ;;
1079 "IPFIRE: Clean")
1080 $0 clean
1081 ;;
1082 "SVN: Update")
1083 $0 svn update
1084 ;;
1085 "Help")
1086 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1087 cat doc/make.sh-usage
1088 ;;
1089 "LOG: Tail")
1090 tail -f log/_*
1091 ;;
1092 "Exit")
1093 break
1094 ;;
1095 esac
1096 done
1097 ;;
1098 config)
1099 make_config
1100 ;;
1101 *)
1102 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1103 cat doc/make.sh-usage
1104 ;;
1105 esac